-- generated by gemini and corrected https://gemini.google.com/app/83f1154fc9da6146

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_TEXTIO.ALL;
use STD.textio.all;

-- Entity declaration for the testbench module
entity tb_RGB_Converter is -- RGB_Converter_TB
  -- No ports required for this testbench
end entity;

architecture Behavioral of tb_RGB_Converter is
  -- Define constants
  constant ROM_FILE_COUNT : integer := 30;
  constant ROM_DATA_WIDTH : integer := 24;  -- Assuming 24-bit RGB888 data
  constant MEM_DATA_WIDTH : integer := 16;  -- Target 16-bit RGB565 memory
  constant MEM_WIDTH : integer := 640;  -- Memory width (columns)
  constant MEM_HEIGHT : integer := 480;  -- Memory height (rows)
  constant hex_rom_files_name : string := "hex_memory_file_frame";
  constant hex_rom_files_ext : string := "hex";

  -- Signal declaration for the 2D memory array
  type mem_t is array (0 to MEM_WIDTH * MEM_HEIGHT - 1) of std_logic_vector (MEM_DATA_WIDTH-1 downto 0);
  shared variable image_mem : mem_t := (others => (others => '0'));
  -- Adjust array bounds to match memory dimensions

  function to_string_1 ( s : std_logic_vector )
    return string
  is
    variable r : string ( s'length downto 1 ) ;
  begin
  --synthesis translate_off
    for i in s'range loop
      r(i+1) := std_logic'image (s(i))(2);
    end loop ;
    return r ;
  --synthesis translate_on
  end function ;

  -- https://stackoverflow.com/a/53391980
  function hex (lvec: in std_logic_vector) return string is
    variable text: string(lvec'length / 4 - 1 downto 0) := (others => '9');
    subtype halfbyte is std_logic_vector(4-1 downto 0);
  begin
    assert lvec'length mod 4 = 0
      report "hex() works only with vectors whose length is a multiple of 4" severity FAILURE;
    for k in text'range loop
      case halfbyte'(lvec(4 * k + 3 downto 4 * k)) is
        when "0000" => text(k) := '0';
        when "0001" => text(k) := '1';
        when "0010" => text(k) := '2';
        when "0011" => text(k) := '3';
        when "0100" => text(k) := '4';
        when "0101" => text(k) := '5';
        when "0110" => text(k) := '6';
        when "0111" => text(k) := '7';
        when "1000" => text(k) := '8';
        when "1001" => text(k) := '9';
        when "1010" => text(k) := 'A';
        when "1011" => text(k) := 'B';
        when "1100" => text(k) := 'C';
        when "1101" => text(k) := 'D';
        when "1110" => text(k) := 'E';
        when "1111" => text(k) := 'F';
          when others => text(k) := '!';
      end case;
    end loop;
    return text;
  end function;

  -- Internal procedure to read a ROM file and convert data
  procedure ReadAndConvertROM (
    filename : in string;
    start_addr : in integer
  ) is
    file F : text; -- for single file append : open read_mode is "input.txt"; , but on list files we have for example "inputINDEX.txt" 
    variable fstatus : file_open_status;
    -- we must delete first character (#) from each line, so we must manipulate input string
    variable file_line : line; -- original line
    variable file_line1 : line; -- changed line (with removed '#' at position 1 in each line)
    variable line_string : string (1 to 7); -- orginal readed string from file_line
    variable line_string1 : string (1 to 7); -- concatenation characters from 2 to 7
    variable data : std_logic_vector (ROM_DATA_WIDTH-1 downto 0); -- string(1 to 80);
    variable rgb_data : unsigned(ROM_DATA_WIDTH-1 downto 0);
    variable rgb565_concat : std_logic_vector (MEM_DATA_WIDTH-1 downto 0);
    variable v_start_address : integer; -- use internal signal for start_addr, because we have IN variable/signal
    variable rgb565_r : std_logic_vector (4 downto 0);
    variable rgb565_g : std_logic_vector (5 downto 0);
    variable rgb565_b : std_logic_vector (4 downto 0);
  begin
    v_start_address := start_addr; -- replace, use 
    file_open (fstatus, F, filename); -- F := text(filename);
    while not endfile(F) loop
      line_string1 := (others => ' '); -- make sure we have empty previous data
      readline (F, file_line); -- file format "#[0-f]{6}\n" (hash and six hexdecimals character)
      read (file_line, line_string); -- from line to string casting (file context)
      -- https://stackoverflow.com/a/41847365
      if line_string'length > 0 then -- not empty
        if line_string(1) = character('#') then -- line have '#' (assume it is not comment)
          line_string1 := line_string(2) & line_string(3) & line_string(4) & line_string(5) & line_string(6) & line_string(7); -- XXX TODO use some shifting
--          report "readed before " & string(line_string1);
          file_line1 := new string(1 to 7); -- https://stackoverflow.com/a/32249431
          file_line1.all(1) := line_string1(1); -- copy, destination is treated as pointer to string record
          file_line1.all(2) := line_string1(2);
          file_line1.all(3) := line_string1(3);
          file_line1.all(4) := line_string1(4);
          file_line1.all(5) := line_string1(5);
          file_line1.all(6) := line_string1(6);
          file_line1.all(7) := line_string1(7); -- copy, destination is treated as pointer to string record
--          report "readed after " & string(file_line1);
        end if;
      end if;
      hread (file_line1, data); -- file have hexdecimals, so use hread from Synopsys file , https://support.xilinx.com/s/question/0D52E00006iI3yrSAC/reading-problem-from-input-file-in-isim?language=en_US
      -- (A) 76543210FEDCBA9876543210 - index for rgb_data slicing (little-endianess order, not reversed, indexed with hexdecimals 0-F, 24bit - 7 downto 0 following 15 downto 0)
      -- (B) RRRRRRRRGGGGGGGGBBBBBBBB - 24bit RGB888 format
      -- (C) ---RRRRR--GGGGGG---BBBBB - 16bit RGB565 format
      -- (D)    RRRRR  GGGGGG   BBBBB - 16bit RGB565 - the same format as (C)
      rgb565_r := data(20 downto 16); -- lower 4-0 from (A)
      rgb565_g := data(13 downto 8); -- middle D-8 from (A)
      rgb565_b := data(4 downto 0); -- upper 4-0 from (A)
      rgb565_concat := rgb565_r & rgb565_g & rgb565_b;
      image_mem(v_start_address) := rgb565_concat;
      v_start_address := v_start_address + 1;
--      report "rgb888 " & " " & hex (data) & " " & to_string_1 (data);
--      report "rgb565 " & " " & hex (rgb565_concat) & " " & to_string_1 (rgb565_concat);
    end loop;
    file_close (F); -- F.Close;
  end procedure;
  
begin

  test1 : process is -- combinatorial
    variable start_addr : integer;
    variable file_name : string (1 to 26);
  begin
    -- Loop through all ROM files and call conversion procedure
--    for i in 1 to ROM_FILE_COUNT loop
    for i in 1 to 1 loop -- for test, only 1 file
      start_addr := 0;
      file_name := hex_rom_files_name & integer'image(i) & "." & hex_rom_files_ext;
      report "ReadAndConvertROM " & file_name;
      ReadAndConvertROM(file_name, start_addr); -- appended : file name,converted integer to string (index file),suffix name 
      wait; -- wait because "Possible infinite loop; process does not have a wait statement" warning in ISE 14.7 ISIM simulator
    end loop;
  end process test1;

  -- Assertions or further processing can be added here based on your testbench requirements

end Behavioral;
